hdu2795-Billboard

Time Limit:8000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u
Submit
 
Status
Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information. 


On September 1, the billboard was empty. One by one, the announcements started being put on the billboard. 


Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi. 


When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one. 


If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university). 


Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 
Input
There are multiple cases (no more than 40 cases). 


The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements. 


Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 
Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 
Sample Input
 3 5 5
2
4
3
3

 
Sample Output
 1
2
1
3

-1 



题目大意:有一个广告板,高度为h长度为w,每次往上面贴高度为1长度为wi的广告,贴广告的规则是只要上

面有空位就往上面贴,剩余的位置不够贴的话就输出-1.

思路:构建一棵线段树,因为高度h大于操作数n的时候h最多用到n所以线段树只要建到80万就行。并且当wi > w时直接可以输出-1.然后每次插入广告更新一次线段树就行了。


代码

#include <iostream>
#include <cstdio>
#include <cstring>
typedef __int64 LL;
using namespace std;
LL w,h,n;
LL max1(LL a, LL b)
{
    return a > b? a:b;
}
struct tree
{
    int l, r;
	LL max;
	int mid()
	{
	    return (l + r)>>1;
	}
}t[1000000];
int ans,ok;
void btree(int l, int r, int now)
{
    t[now].l = l;
	t[now].r = r;
	t[now].max = w;
	if(l == r)
		return;
	int mid = t[now].mid();
	btree(l ,mid, now<<1);
	btree(mid+1,r,now<<1|1);
}                                               //max 代表当前区间里面最大的剩余位置,最大的剩余位置一开始全部初始化为w
void Q(int l,int r, int now, LL len)
{
    if(l == r&&t[now].max >= len)                //肯定是在底节点找到的
	{
	    ans = l;
		t[now].max -= len;
		return;
	}
	if(l >=r)
		return ;
	int mid = t[now].mid();
	if(t[now<<1].max>=len)                      //如果当前区间的左区间有剩余位置就插入左区间,否则就插入右区间,因为是往最高的地方插入所以要先保证前面没地方插入了
	{
	    Q(l,mid,now<<1,len);
	}
	else 
	{
	    Q(mid+1,r,now<<1|1,len);
	}
	t[now].max = max1(t[now<<1].max,t[now<<1|1].max);     //更新区间的最大值
}                                                       
int main()
{
    int i;
	while (scanf("%I64d %I64d %d",&h,&w,&n)!=EOF)
	{
	    if(h > n)
		{
		    h = n;
		}
		btree(1,h,1);
		int wi;
		for(i = 0; i < n; i++)
		{
			ans = 0;
			ok = 0;
		    scanf("%I64d",&wi);
			if(wi > w)
				printf("-1\n");
			else 
			{
			    Q(1,h,1,wi);
				if(ans != 0)
			        printf("%d\n",ans);
				else 
					cout<<"-1"<<endl;
			}
		}
	}
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值